function [selectedDeck, respTime, randomSelect] = GetResp(decks, myPort, modelCommID)
    %disp('In GetResp');
    selectedDeck = [];
    randomSelect = 0;
    respTime = 0;
    startTime = [];
    tempDeck = [];
    %startRespTime = GetSecs();
    glyphs = ['!', '@', '#', '$', '%', '^', '&', '*', '('];
    startResp = tic;
    
    if( myPort ~= -1 )
        %(Need to change this to 3 when testing on my (CLD) normal laptop)
        KbQueueCreate(3);
        KbQueueStart(3);
    end
    if( myPort == -1 )

        TimeMsg(modelCommID);
        while( isempty(selectedDeck) )
            modelMsg = pnet(modelCommID, 'read', 'noblock');

            if( ~isempty(strfind(modelMsg, '"keypress",')) )
                keyCodeLoc = strfind(modelMsg, '"keycode":') + 10;
                endKeyCodeLoc = strfind(modelMsg(keyCodeLoc:end), '}');
                tempDeck = modelMsg(keyCodeLoc:keyCodeLoc+endKeyCodeLoc(1)-2);
                tempDeck = str2double(tempDeck);
                tempDeck = char(tempDeck);

                if( length(modelMsg) <= 1 )
                    modelMsg = pnet(modelCommID, 'read', 'noblock');
                end

                %If we didn't have a set-mp-time (ACT-R time) message
                %waiting to be digested, we request the time from ACT-R
                if( isempty(strfind(modelMsg, 'set-mp-time')))
                    TimeMsg(modelCommID);
                    while(isempty(strfind(modelMsg, 'set-mp-time')))
                       modelMsg = pnet(modelCommID, 'read', 'noblock');
                    end
                end

                SyncMsg(modelCommID);
                currTime = ConvertJSONTime(modelMsg);
                respTime = currTime-startTime;
            elseif( ~isempty(modelMsg) )
                if( ~isempty(strfind(modelMsg, '"set-mp-time"')) )
                    if( isempty(startTime) )
                        startTime = ConvertJSONTime(modelMsg);
                    else
                        currTime = ConvertJSONTime(modelMsg);
                        respTime = currTime-startTime;
                    end
                    SyncMsg(modelCommID);
                    if( respTime < 3.5 )
                        TimeMsg(modelCommID);
                    end
                else
                    SyncMsg(modelCommID);
                    continue;
                end
            else
                continue;
            end
            
            %Test for selections from any other number of decks (up to 9)
            for i = 1:(size(decks.index, 2))
                keyGlyphTest = strcat(num2str(i), glyphs(i));
                if( strcmpi(tempDeck, num2str(i)) || ...
                     strcmpi(tempDeck, char(i+96)) || ...
                     strcmpi(tempDeck, keyGlyphTest) )

                    if( decks.index(1,i) > 40 )
                        continue
                    else
                        selectedDeck = tempDeck;
                        break;
                    end
                end
            end
        end
    else
        breakOutter = 0;
        while( respTime < 3.5 )
            %(Need to change KbQueueCheck to 3 when testing on my (CLD) normal laptop)
            [ keyIsDown, fP, fR, lP, lR ] = KbQueueCheck(3);
            respTime = toc(startResp);
            if( isempty(KbName(fP)) || length(find(fP)) ~= 1)
                continue;
            end
            
            if( keyIsDown )
                %Get key values for any other number of decks (up to 9)
                for i = 1:(size(decks.index, 2))
                    keyGlyphTest = strcat(num2str(i), glyphs(i));

                    if( strcmpi(KbName(fP), num2str(i)) || ...
                         strcmpi(KbName(fP), char(i+96)) || ...
                         strcmpi(KbName(fP), keyGlyphTest) )
                     
                        if( decks.index(1,i) > 40 )
                            continue;
                        else
                            selectedDeck = KbName(fP);
                            breakOutter = 1;
                            break;
                        end
                    end
                end
                
                if( breakOutter )
                    break;
                end

                if( strcmpi(KbName(fP), 'escape') )
                    selectedDeck = KbName(fP);
                    break;
                elseif( strcmpi(KbName(fP), '\') )
                    selectedDeck = KbName(fP);
                    break;
                end    
            end
        end
    end
    if( myPort ~= -1 )
        %(Need to change this to 3 when testing on my (CLD) normal laptop)
        KbQueueStop(3);
        KbQueueFlush(3);
    end
    
    if( isempty(selectedDeck) )
        rNum = randperm(size(decks.index, 2));
        selectedDeck = num2str(rNum(1));
        rNumCount = 2;
        while( decks.index(1, str2double(selectedDeck)) >= 40 )
            selectedDeck = num2str(rNum(rNumCount));
            if( myPort == -1 )
                %pnet(modelCommID, 'write', sprintf(char('Matlab-Skipped\n')));
            end
            rNumCount = rNumCount + 1;
        end
        randomSelect = 1;
    end
end