%%
%JSON Message Function
%Timer callback function that is used to collect the non-important messages
%sent to matlab from the model (those we don't explicitly use)
function CheckSocketMsgs(obj, event, modelCommID)
    IGTMsg = pnet(modelCommID, 'read', 'noblock', 'view');
            
    if( ~isempty(strfind(IGTMsg, 'gaze-loc')) || ...
            ~isempty(strfind(IGTMsg, 'mouseclick')) || ...
            ~isempty(strfind(IGTMsg, 'mousemotion')) || ...
            ~isempty(strfind(IGTMsg, 'speak')) || ...
            ~isempty(strfind(IGTMsg, 'attention-loc')) || ...
            ~isempty(strfind(IGTMsg, 'mouseclick')) )
        IGTMsg = pnet(modelCommID, 'read', 'noblock');
        disp(IGTMsg);
        disp('In timer');
        SyncMsg(modelCommID);
    end
    
end

