function stim = GetStimuli(imgFolder)
    imgFolders = dir(imgFolder);
    stim = {};
    for i=1:length(imgFolders)
        folderName = fullfile(imgFolder, imgFolders(i).name);
        if( isdir(folderName) && ~strcmp(imgFolders(i).name, '.') ...
                && ~strcmp(imgFolders(i).name, '..') )
%             if( ~strcmpi(imgFolders(i).name, 'Neg') )
%                 continue;
%             end
            imgs = dir(folderName);
            temp = {imgFolders(i).name};
            for j=1:length(imgs)
                imgName = fullfile(folderName, imgs(j).name);
                if( ~isdir(imgName) )
                    temp = [temp, {imgName}];
                end
            end
            stim = [stim; temp];
        end
    end
end
