%Function used for break between trials (i.e., card selection)
function InterTrialBreak(wPtr, breakLength, stimBoxParam, serialFile, myPort, maxComponents, eyeStartTime)
    startBreakTime = 0;
    black = BlackIndex(wPtr);
    gray = (WhiteIndex(wPtr) + black) / 2;
    msgText = 'Get ready to make next trial selection';
    textX = stimBoxParam(1) + ((stimBoxParam(3)-stimBoxParam(1))*0.1);
    textY = stimBoxParam(2) + ((stimBoxParam(4)-stimBoxParam(2))*0.5);
    %Screen('FillRect', wPtr, [gray gray gray], stimBoxParam');
    Screen('Preference', 'TextAlphaBlending', 1);
    Screen('TextFont', wPtr, char('Helvetica'));
    Screen('TextStyle', wPtr, 8);
    Screen('TextSize', wPtr, 16);
    Screen('TextBackgroundColor', wPtr, [255 255 255]);
    readyText = Screen('DrawText', wPtr, msgText, textX+10, textY, black);
    Screen('Flip', wPtr, [], 1);
    Screen('Preference', 'TextAlphaBlending', 0);
    
    startBreakTime = tic;
    disp(breakLength)

    while toc(startBreakTime) < breakLength
        disp(toc(startBreakTime))
        if( myPort ~= -1 )
            if( myPort )
                InterTrialDataCollect(serialFile, myPort, maxComponents, eyeStartTime);
            end
        end
    end
end

